//
//  File.c
//  appwebservicePOST
//
//  Created by Administrator on 7/30/13.
//  Copyright (c) 2013 Administrator. All rights reserved.
//

#include "wordtab.h"

int     match_caractere(char caractere, const char *str_parse)
{
    int i;
    
    if (str_parse == NULL)
        return (0);
    i = -1;
    while (str_parse[++i] != '\0') {
        if (str_parse[i] == caractere)
            return (1);
    }
    return (0);
}

int     number_word(char *string, const char *str_parse)
{
    int i;
    int word;
    int nb_word;
    
    if (string == NULL || string[0] == '\0')
        return (0);
    nb_word = 0;
    i = -1;
    word = 0;
    while (string[++i] != '\0') {
        if (match_caractere(string[i], str_parse) != 1)
        {
            if (word == 0)
            {
                nb_word += 1;
                word = 1;
            }
        }
        else
            word = 0;
    }
    return (nb_word);
}

void    find_word(char *string, const char *str_parse,
                  int *start_str, int *size)
{
    int i;
    
    if (string == NULL)
        return ;
    i = *start_str - 1;
    while (string[++i] != '\0' &&
           match_caractere(string[i], str_parse) == 1);
    *start_str = i;
    if (string[i] == '\0')
    {
        *start_str = i;
        return ;
    }
    while (string[++i] != '\0' &&
           match_caractere(string[i], str_parse) == 0)
        ++*size;
    ++*size;
}

char        **wordtab(char *string, const char *str_parse)
{
    char    **tab;
    int     size;
    int     i;
    int     i_str;
    int     start_str;
    int     size_str;
    
    if ((size = number_word(string, str_parse)) == 0 ||
        (tab = malloc(sizeof(char *) * (size + 1))) == NULL)
        return (NULL);
    i = -1;
    start_str = 0;
    while (++i < size) {
        size_str = 0;
        find_word(string, str_parse, &start_str, &size_str);
        if ((tab[i] = malloc(size_str + 1)) == NULL)
        {
            free(tab);
            return (NULL);
        }
        i_str = -1;
        while (++i_str < size_str)
            tab[i][i_str] = string[i_str + start_str];
        tab[i][i_str] = '\0';
        start_str += size_str;
    }
    tab[i] = NULL;
    return (tab);
}

void    free_tab(char **tab)
{
    int i;
    
    if (tab == NULL)
        return ;
    i = -1;
    while (tab[++i] != NULL)
        free(tab[i]);
    free(tab);
}

int    size_tab(char **tab)
{
    int i;
    
    if (tab == NULL)
        return (0);
    i = -1;
    while (tab[++i] != NULL);
    return (i);
}

void    view_tab(char **tab)
{
    int i;
    
    if (tab == NULL)
        return ;
    i = -1;
    while (tab[++i] != NULL)
        printf("[%d] => {%s}\n", i, tab[i]);
}
